<div align="center">
<img src="doc/binhop.png" alt="Binhop Logo">

# binhop
  
binhop is a **file carving visualizer**, powered by binwalk.

It makes clear what parts of a blob can be extracted, so you can
take action on the parts that didn't.<br />
binhop relies entirely on a functioning installation of binwalk.

[Usage](#usage) •
[Installation](#installation) •
[Contributing](#contributing) •
[License](#license)
</div>

## Usage

To use the script, run the following command:

```
binhop <path-to-binary-file>
```

Alternatively, you can run binhop on data from STDIN like so:

```
binhop < <path-to-binary-file-or-stream>
```

## Installation

To use this script, you need Python 3 and a functioning and "recent" version of `binwalk` installed on your system. You'll probably also want to install optional `binwalk` dependencies such as `sasquatch`, `jefferson`, and others. You can learn how to do that in the [binwalk documentation](https://github.com/ReFirmLabs/binwalk/blob/master/INSTALL.md).

When that's done, install the Python dependencies for `binhop`, running something like:

```
git clone https://github.com/darrylnixon/binhop.git
cd binhop
pip install -r requirements.txt
pip install .
```

## Contributing

If you would like to contribute to this project, feel free to submit a pull request or open an issue on GitHub.

This tool was written as part of my coursework for CSC 842 - Security Tool Development at Dakota State University. Consequently, I may choose not to maintain this tool beyond the length of the course, but have selected a license that enables open contributions in any case.

## License

This project is licensed under the GPLv3 License, because it's important to give back. See the `LICENSE` file for details.